<template>
  <main ref="main" class="WeekPlanning">
    <Filters />
    <div class="WeekPlanning__Scroller">
      <div class="WeekPlanning__Timelines">
        <DayBars />
        <Ruler />
        <component
          :is="laneComponent"
          v-for="headId of keys"
          :key="[headId, config.row].join('_')"
          :head-id="headId"
        />
      </div>
    </div>
  </main>
  <Backlog class="WeekPlanning__Backlog" />
</template>

<script lang="ts" setup>
import Filters from './Filters.vue'
import BusinessCaseLane from './BusinessCaseLane.vue'
import WorkforceLane from './WorkforceLane.vue'
import Ruler from './Ruler.vue'
import DayBars from './DayBars.vue'
import Backlog from './Backlog.vue'
import { useI18n } from 'vue-i18n'
import {
  computed,
  onMounted,
  onUnmounted,
  provide,
  ref,
  watch,
  watchEffect,
} from 'vue'
import { config, getAllVisibleTasks, taskTree } from '@/states/weekPlanning'
import {
  FocusIdKey,
  ProvidedResources,
  ResourcesKey,
  SettingsKey,
} from '@/provided'
import { BY_BUSINESS_CASE, planningSettingsClient } from '@/api'
import { ROUTES } from '@/plugins'
import { RouteParamsRaw, useRouter } from 'vue-router'
import { injectStrict } from '@/injectStrict'

const props = defineProps<{
  idSettings?: string | null
}>()

const { t } = useI18n()
const main = ref<HTMLElement | null>(null)
const laneComponent = computed(() => {
  if (config.row === BY_BUSINESS_CASE) return BusinessCaseLane
  return WorkforceLane
})

provide(FocusIdKey, ref<undefined | string>(undefined))

const settings = injectStrict(SettingsKey)
const Resources = injectStrict<ProvidedResources>(ResourcesKey)

const keys = computed(() => {
  const keys = Array.from(taskTree.current.value.keys())
  keys.sort((k1, k2) => {
    if (!k1) return -1
    return k1?.localeCompare(k2 || '')
  })
  return keys
})

onMounted(async () => {
  await getAllVisibleTasks(t)
})

onUnmounted(() => {
  taskTree.stopLiveReload()
})

watchEffect(async () => {
  if (props.idSettings) {
    const planningSettings = await planningSettingsClient.getItem(
      props.idSettings
    )
    if (planningSettings) {
      settings.planningSettings = planningSettings
      return
    }
  }
})

const router = useRouter()

watch(
  () => settings.planningSettings,
  async () => {
    const params: RouteParamsRaw = {}
    if (settings.planningSettings)
      params.idSettings = settings.planningSettings.id

    await router.push({ ...ROUTES.WEEK_PLANNING, params })
  }
)

watch(
  () => config,
  () => getAllVisibleTasks(t),
  { deep: true }
)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use './weekPlanning' as wp;

.WeekPlanning {
  display: flex;
  flex-direction: column;
  min-height: 100%;
  max-height: 100%;
  padding: v.$spacing;

  &__Timelines {
    position: relative;
  }

  &__Scroller {
    overflow: auto;
  }

  &__Backlog {
    grid-area: r-sideBar;
  }
}
</style>
